#<profile4xi profile = "10" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "sub_warning4xi.py">
#<abstract4xi abstract = "provides the function sub_warning4xi"/>
#<refer4xi reference = "util.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'sub_warning4xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import itertools
    import weakref
    import logging         
except:
    pass
try:                 # rare ones
    import atexit          
except:
    pass 
try:                 # imported-as ones 
    pass           
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    pass
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import logger4xi
from print4xi import print4xi
from time4xi import time4xi 
#"
#/>


# -------------------------------------------------------------------------------------------------
# Constants                              
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
#<function4xi function = "sub-warning4xi" usage = "
#   reduction.py: 
#       try:
#             ....
#       except:
#           if not is_exiting():
#                import traceback 
#                sub_warning('thread for sharing handles raised exception :\n' + '-'*79 + '\n' + traceback.format_exc() + '-'*79)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def sub_warning4xi(msg, *args):
    '''
    provides subwarning messages
    '''
                  
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
  
    class2print = "sub_warning4xi"
    method2print = "sub_warning4xi"
    
    message2print = "{started" + "; sub-warning4xi-started: " + str(sub_warning4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
   
                
    # ---------------------------------------------------------------------------------------------    
    #
    # --------------------------------------------------------------------------------------------- 
        
    message2print = "{passing" + "; msg-passing-to-print4xi-by-sub-warning4xi: " + str(msg) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{informing" + "; replace-informing-by-info4xi: " + " * replace sub_warning4xi calls with print4xi calls !"  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{returning" + "; sub-warning4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
        
            
        
#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of sub_warning4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
